/*  RAGE2X for GP2X

    Copyright (C) 2006  JyCet

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

void load_preview(unsigned char numero)
{
	//preview
	sprintf((char*)g_string, "preview/%s.bmp",data.zip[list[numero][options.listing]]);
	if ((fp = fopen(g_string, "r")) != NULL){
		Tmp = SDL_LoadBMP(g_string);
		preview = SDL_DisplayFormat(Tmp);
		SDL_FreeSurface(Tmp);
		//preview = SDL_LoadBMP(g_string);
		fclose(fp);
	}else{
		//rw = SDL_RWFromMem(spr_NOPRW,sizeof(spr_NOPRW)/sizeof(unsigned char));
		//preview = SDL_LoadBMP_RW(rw,0);
		drawSprite(preview0, preview, 0, 0, 0, 0, 152, 112);
	}
	
	//check presence fichier config
	sprintf((char*)g_string, "conf/%s.cf",data.zip[list[numero][options.listing]]);
	conf.cpu_speed = "N/A";
	conf.clock68k = "N/A";
	conf.z80clock = "N/A";
	conf.sound = "N/A";
	conf.samplerate = "N/A";
	conf.showfps = "N/A";
	conf.raster = "N/A";
	conf.system = "N/A";
	conf.country = "N/A";
	conf.screen320 = "N/A";
	if ((fp = fopen(g_string, "r")) != NULL){
		flag_cf_file=1;
		while(fgets(ligne,sizeof(ligne),fp) != NULL){
			sscanf(ligne, "%s %s", &arg1,&arg2);
			if (strcmp(arg1,"#")!=0){
				if (strcmp(arg1,"cpu_speed")==0){
					conf.cpu_speed = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.cpu_speed,arg2);
				}else if (strcmp(arg1,"68kclock")==0){
					conf.clock68k = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.clock68k,arg2);
				}else if (strcmp(arg1,"z80clock")==0){
					conf.z80clock = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.z80clock,arg2);
				}else if (strcmp(arg1,"sound")==0){
					conf.sound = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.sound,arg2);
				}else if (strcmp(arg1,"samplerate")==0){
					conf.samplerate = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.samplerate,arg2);
				}else if (strcmp(arg1,"showfps")==0){
					conf.showfps = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.showfps,arg2);
				}else if (strcmp(arg1,"raster")==0){
					conf.raster = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.raster,arg2);
				}else if (strcmp(arg1,"system")==0){
					conf.system = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.system,arg2);
				}else if (strcmp(arg1,"country")==0){
					conf.country = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.country,arg2);
				}else if (strcmp(arg1,"screen320")==0){
					conf.screen320 = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(conf.screen320,arg2);
				}
			}
		}fclose(fp);
	}else{
		flag_cf_file=0;
	}
	
}

#ifdef CAANOO
void load_joycfg(void)
{
	char buf[256];
	char *ptr;
	unsigned int *ptr2=NULL;
	int count=0;

	snprintf(buf,255,"conf/usbjoy%d.cfg",(options.usbjoy1+1));
	fp=fopen(buf,"rt");
	if(fp)
	{
		while(fgets(buf,256,fp))
		{
			if(*buf!='#')
			{
				ptr=strtok(buf," ");
				ptr2=NULL;
				count=0;

				if(strcmp(ptr,"usbjoy_rage2x")==0) ptr2=rage2x_joycfg[1];
				else if(strcmp(ptr,"usbjoy_gngeo")==0) ptr2=gngeo_joycfg[0];

				if(ptr2)
				{					
					while(ptr=strtok(NULL,","))
					{
						ptr2[count]=atoi(ptr);
						count++;
						if(count>=10) break;
					}
				}
			}
		}
		fclose(fp);
	}

	snprintf(buf,255,"conf/usbjoy%d.cfg",(options.usbjoy2+1));
	fp=fopen(buf,"rt");
	if(fp)
	{
		while(fgets(buf,256,fp))
		{
			if(*buf!='#')
			{
				ptr=strtok(buf," ");
				ptr2=NULL;
				count=0;

				if(strcmp(ptr,"usbjoy_rage2x")==0) ptr2=rage2x_joycfg[2];
				else if(strcmp(ptr,"usbjoy_gngeo")==0) ptr2=gngeo_joycfg[1];

				if(ptr2)
				{					
					while(ptr=strtok(NULL,","))
					{
						ptr2[count]=atoi(ptr);
						count++;
						if(count>=10) break;
					}
				}
			}
		}
		fclose(fp);
	}
}
#endif

void load_cfg(void)
{
	int temp1,temp2,temp3,temp4;

	// force les settings si un parametre est absent
	options.path[0]="roms/";
	options.path[1]="/mnt/sd/roms/neogeomvs/";
	options.fps=0;
#ifdef CAANOO
	options.sound=1;
	options.rate=1;
	options.cpu=4;
#else
	options.sound=0;
	options.rate=0;
	options.cpu=200;
#endif
	options.cpu68k=0;
	options.cpuz80=0;
#ifdef CAANOO
	options.reload=1;
#else
	options.reload=0;
#endif
	options.raster=0;
	options.largeur=1;
	options.system=0;
	options.pays=0;
	options.guispeed=1;
	options.langue=0; //english
	options.listing=0; //voir toute la liste
	options.inv_run=0; //ordre normal
#ifdef CAANOO
	options.rage2xclock=1;
#else
	options.rage2xclock=100;
#endif
	options.scrollbg=1;

	options.tweak=0;
	options.vsync=0;
	options.tvout=0;
	options.tvoffset_x=0;
	options.tvoffset_y=0;
	options.dumpsprite=0;

#ifdef CAANOO
	options.usbjoy1=0;
	options.usbjoy2=0;
	options.doublebuf=0;
#endif
	
	rage2x_cmd.save = 0xffff ; // active toutes les options externes par defaut

	quit.path = "/usr/gp2x/" ;
	quit.prg = "gp2xmenu" ;
	quit.temp = "/usr/gp2x/gp2xmenu" ;

	//lire le fichier de configuration
	if ((fp = fopen("rage2x.cfg", "r")) != NULL){
		while(fgets(ligne,sizeof(ligne),fp) != NULL){
			sscanf(ligne, "%s %d", &arg1,&argd);
			if (strcmp(arg1,"#")!=0){
				if (strcmp(arg1,"romspath1")==0){
					sscanf(ligne, "%s %s", &arg1,&arg2);
					options.path[0] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(options.path[0],arg2);
				}
				else if (strcmp(arg1,"romspath2")==0){
					sscanf(ligne, "%s %s", &arg1,&arg2);
					options.path[1] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(options.path[1],arg2);
				}
				else if (strcmp(arg1,"showfps")==0) options.fps=argd;
				else if (strcmp(arg1,"sound")==0) options.sound=argd;
				else if (strcmp(arg1,"samplerate")==0) options.rate=argd;
				else if (strcmp(arg1,"raster")==0) options.raster=argd;
				else if (strcmp(arg1,"screen")==0) options.largeur=argd;
				else if (strcmp(arg1,"system")==0) options.system=argd;
				else if (strcmp(arg1,"country")==0) options.pays=argd;
				else if (strcmp(arg1,"cpuclock")==0) options.cpu=argd;
				else if (strcmp(arg1,"cpu68k")==0) options.cpu68k=argd;
				else if (strcmp(arg1,"cpuz80")==0) options.cpuz80=argd;
				else if (strcmp(arg1,"guispeed")==0) options.guispeed=argd;
				else if (strcmp(arg1,"autoreloadgui")==0) options.reload=argd;
				else if (strcmp(arg1,"guilangue")==0) options.langue=argd;
				else if (strcmp(arg1,"guilisting")==0) options.listing=argd;
				else if (strcmp(arg1,"invertrun")==0) options.inv_run=argd;
				else if (strcmp(arg1,"rage2xclock")==0) options.rage2xclock=argd;

				else if (strcmp(arg1,"rage2xscrollbg")==0) options.scrollbg=argd;
				else if (strcmp(arg1,"rage2x_cmd")==0){
					sscanf(ligne, "%s %d", &arg1,&argd2);
					rage2x_cmd.save = argd2;
				}
				else if (strcmp(arg1,"exit_program")==0){
					sscanf(ligne, "%s %s", &arg1,&arg2);
					quit.temp = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy( quit.temp , arg2 );
				}
				

				else if (strcmp(arg1,"tweak")==0) options.tweak=argd;
				else if (strcmp(arg1,"vsync")==0) options.vsync=argd;
				else if (strcmp(arg1,"tvout")==0) options.tvout=argd;
				else if (strcmp(arg1,"tvoffset_x")==0) options.tvoffset_x=argd;
				else if (strcmp(arg1,"tvoffset_y")==0) options.tvoffset_y=argd;
				else if (strcmp(arg1,"dumpsprite")==0) options.dumpsprite=argd;
#ifdef CAANOO
				else if (strcmp(arg1,"usbjoy1")==0) options.usbjoy1=argd;
				else if (strcmp(arg1,"usbjoy2")==0) options.usbjoy2=argd;
				else if (strcmp(arg1,"doublebuf")==0) options.doublebuf=argd;
#endif
			}
		}
		fclose(fp);
	}else{
		write_cfg();
	}
	
	//check tous les settings et corrige si besoin
	options.fps &= 1;
	options.sound &= 1;
	if (options.rate > 2) options.rate = 0;		//defaut
	options.raster &= 1;
	options.largeur &= 1;
	if (options.system > 2) options.system = 0;	//defaut
	if (options.pays > 2) options.pays = 0;		//defaut
#ifdef CAANOO
	if (options.cpu < 4) options.cpu = 4;
	else if (options.cpu > 10) options.cpu = 10;
#else
	if (options.cpu < 100) options.cpu = 100;
	else if (options.cpu > 310) options.cpu = 310;
#endif
	if (options.cpu68k < -50) options.cpu68k = -50;
	else if (options.cpu68k > 50) options.cpu68k = 50;
	if (options.cpuz80 < -50) options.cpuz80 = -50;
	else if (options.cpuz80 > 50) options.cpuz80 = 50;
	if (options.guispeed > 2) options.guispeed = 1;	//defaut
	options.reload &= 1;
	if (options.langue > 9) options.langue = 0;	//defaut
	if (options.listing > 2) options.listing = 0;	//defaut
	options.inv_run &= 1;
#ifdef CAANOO
	if (options.rage2xclock < 0) options.rage2xclock = 0;
	else if (options.rage2xclock > 4) options.rage2xclock = 4;
	if(options.usbjoy1<0) options.usbjoy1=0;
	else if(options.usbjoy1>=joycfg_count) options.usbjoy1=joycfg_count-1;
	if(options.usbjoy2<0) options.usbjoy2=0;
	else if(options.usbjoy2>=joycfg_count) options.usbjoy2=joycfg_count-1;
#else
	if (options.rage2xclock < 66) options.rage2xclock = 66;
	else if (options.rage2xclock > 133) options.rage2xclock = 133;
#endif
		
	// /usr/gp2x/gp2xmenu
	temp1=temp2=temp4=0;
	//comptage de rep
	unsigned carac;
	for ( carac=0 ; carac<strlen( quit.temp ) ; ++carac )
		if (quit.temp[carac]==47) ++temp1; // 47 = '/'
	//comptage position rep -1
	for ( carac=0 ; carac<strlen( quit.temp ) ; ++carac ){
		if (quit.temp[carac]==47) { // 47 = '/'
			++temp2;
			if (temp2==temp1){
				temp4 = (carac+1) ;
			}
		}
	}
	//quit1=temp1;
	//quit2=temp4;
	quit.path = (char*) calloc( temp4 + 1 , sizeof(char)); // sans le '/'
	strncpy(quit.path , quit.temp , temp4 );
	quit.prg = (char*) calloc( strlen( quit.temp ) - temp4 + 1 , sizeof(char));
	strncpy( quit.prg , (quit.temp + temp4) , (strlen( quit.temp ) - temp4) );
	printf("quit_path = %s\n",quit.path);
	printf("quit_prg = %s\n",quit.prg);

#ifdef CAANOO
	load_joycfg();
#endif
}

void load_lng(void)
{
	
	//lecture fichier de langue
	error.lng=0;
	lng_num=0;
	if ((fp = fopen("rage2x.lng", "r")) != NULL){
		while(fgets(ligne,sizeof(ligne),fp) != NULL){
			sscanf(ligne, "%s %s", &arg1,&arg2);
			if (strcmp(arg1,"#")!=0){
				if (strcmp(arg1,"1:")==0){
					txt[TXT_GAME_INFORMATION][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_GAME_INFORMATION][lng_num],arg2);
				}else if (strcmp(arg1,"2:")==0){
					txt[TXT_GAMES_IN_DATABASE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_GAMES_IN_DATABASE][lng_num],arg2);
				}else if (strcmp(arg1,"3:")==0){
					txt[TXT_GAMES_AVAILABLE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_GAMES_AVAILABLE][lng_num],arg2);
				}else if (strcmp(arg1,"4:")==0){
					txt[TXT_SHOW_FRAMERATE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SHOW_FRAMERATE][lng_num],arg2);
				}else if (strcmp(arg1,"5:")==0){
					txt[TXT_ACTIVATE_SOUND][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_ACTIVATE_SOUND][lng_num],arg2);
				}else if (strcmp(arg1,"6:")==0){
					txt[TXT_CPU_SPEED][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_CPU_SPEED][lng_num],arg2);
				}else if (strcmp(arg1,"7:")==0){
					txt[TXT_GUI_SPEED][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_GUI_SPEED][lng_num],arg2);
				}else if (strcmp(arg1,"8:")==0){
					txt[TXT_AUTO_RELOAD_GUI][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_AUTO_RELOAD_GUI][lng_num],arg2);
				}else if (strcmp(arg1,"9:")==0){
					txt[TXT_ACTIVATE_RASTER][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_ACTIVATE_RASTER][lng_num],arg2);
				}else if (strcmp(arg1,"10:")==0){
					txt[TXT_INVERT_RUN_CHOICE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_INVERT_RUN_CHOICE][lng_num],arg2);
				}else if (strcmp(arg1,"11:")==0){
					txt[TXT_RESOLUTION_320x224][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_RESOLUTION_320x224][lng_num],arg2);
				}else if (strcmp(arg1,"12:")==0){
					txt[TXT_SYSTEM_CONSOLE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SYSTEM_CONSOLE][lng_num],arg2);
				}else if (strcmp(arg1,"13:")==0){
					txt[TXT_SYSTEM_ARCADE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SYSTEM_ARCADE][lng_num],arg2);
				}else if (strcmp(arg1,"14:")==0){
					txt[TXT_SYSTEM_UNIBIOS][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SYSTEM_UNIBIOS][lng_num],arg2);
				}else if (strcmp(arg1,"15:")==0){
					txt[TXT_COUNTRY_JAPAN][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_COUNTRY_JAPAN][lng_num],arg2);
				}else if (strcmp(arg1,"16:")==0){
					txt[TXT_COUNTRY_USA][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_COUNTRY_USA][lng_num],arg2);
				}else if (strcmp(arg1,"17:")==0){
					txt[TXT_COUNTRY_EUROPE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_COUNTRY_EUROPE][lng_num],arg2);
				}else if (strcmp(arg1,"18:")==0){
					txt[TXT_ENGLISH_LANGUAGE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_ENGLISH_LANGUAGE][lng_num],arg2);
				}else if (strcmp(arg1,"19:")==0){
					txt[TXT_SEE_COMPLETE_LIST][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SEE_COMPLETE_LIST][lng_num],arg2);
				}else if (strcmp(arg1,"20:")==0){
					txt[TXT_SEE_LIST_AVAILABLE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SEE_LIST_AVAILABLE][lng_num],arg2);
				}else if (strcmp(arg1,"21:")==0){
					txt[TXT_SEE_MISSING_LIST][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SEE_MISSING_LIST][lng_num],arg2);
				}else if (strcmp(arg1,"22:")==0){
					txt[TXT_SAVE_ALL_SETTING][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_SAVE_ALL_SETTING][lng_num],arg2);
				}else if (strcmp(arg1,"23:")==0){
					txt[TXT_GENERATE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_GENERATE][lng_num],arg2);
				}else if (strcmp(arg1,"24:")==0){
					txt[TXT_68K_CLOCK][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_68K_CLOCK][lng_num],arg2);
				}else if (strcmp(arg1,"25:")==0){
					txt[TXT_Z80_CLOCK][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_Z80_CLOCK][lng_num],arg2);
				}else if (strcmp(arg1,"26:")==0){
					txt[TXT_RUN_WITHOUT][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_RUN_WITHOUT][lng_num],arg2);
				}else if (strcmp(arg1,"27:")==0){
					txt[TXT_RUN_WITH][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_RUN_WITH][lng_num],arg2);
				}else if (strcmp(arg1,"28:")==0){
					txt[TXT_RETURN_TO_GAME_LIST][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_RETURN_TO_GAME_LIST][lng_num],arg2);
				}else if (strcmp(arg1,"29:")==0){
					txt[TXT_EXIT_RAGE2X][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_EXIT_RAGE2X][lng_num],arg2);
				}else if (strcmp(arg1,"30:")==0){
					txt[TXT_RAGE2X_CLOCK][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_RAGE2X_CLOCK][lng_num],arg2);
				}else if (strcmp(arg1,"31:")==0){
					txt[TXT_CRAIGX_RAM_TIMING][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_CRAIGX_RAM_TIMING][lng_num],arg2);
				}else if (strcmp(arg1,"32:")==0){
					txt[TXT_VSYNC][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_VSYNC][lng_num],arg2);
				}else if (strcmp(arg1,"33:")==0){
					txt[TXT_TVOUT][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_TVOUT][lng_num],arg2);
				}else if (strcmp(arg1,"34:")==0){
					txt[TXT_TV_SCREEN_OFFSET_X][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_TV_SCREEN_OFFSET_X][lng_num],arg2);
				}else if (strcmp(arg1,"35:")==0){
					txt[TXT_TV_SCREEN_OFFSET_Y][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_TV_SCREEN_OFFSET_Y][lng_num],arg2);
				}else if (strcmp(arg1,"36:")==0){
					txt[TXT_DUMP_SPRITE][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_DUMP_SPRITE][lng_num],arg2);
				}else if (strcmp(arg1,"37:")==0){
					txt[TXT_WALLPAPER_SCROLLING][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_WALLPAPER_SCROLLING][lng_num],arg2);
/*********************************************************************************************************************************************/
				}else if (strcmp(arg1,"38:")==0){
					txt[TXT_EDIT_ROMS_PATH_1][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_EDIT_ROMS_PATH_1][lng_num],arg2);
				}else if (strcmp(arg1,"39:")==0){
					txt[TXT_EDIT_ROMS_PATH_2][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_EDIT_ROMS_PATH_2][lng_num],arg2);
				}else if (strcmp(arg1,"40:")==0){
					txt[TXT_EDIT_EXIT_PROGRAM][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_EDIT_EXIT_PROGRAM][lng_num],arg2);
				}else if (strcmp(arg1,"41:")==0){
					txt[TXT_Actual_path][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_Actual_path][lng_num],arg2);
				}else if (strcmp(arg1,"42:")==0){
					txt[TXT_New_path][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_New_path][lng_num],arg2);
				}else if (strcmp(arg1,"43:")==0){
					txt[TXT_CANCEL][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_CANCEL][lng_num],arg2);
				}else if (strcmp(arg1,"44:")==0){
					txt[TXT_APPLY][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_APPLY][lng_num],arg2);
				}else if (strcmp(arg1,"45:")==0){
					txt[TXT_RESTORE_DEFAULT_PATH][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_RESTORE_DEFAULT_PATH][lng_num],arg2);
#ifdef CAANOO
				}else if (strcmp(arg1,"46:")==0){
					txt[TXT_USBJOY1][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_USBJOY1][lng_num],arg2);
				}else if (strcmp(arg1,"47:")==0){
					txt[TXT_USBJOY2][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_USBJOY2][lng_num],arg2);
				}else if (strcmp(arg1,"48:")==0){
					txt[TXT_DOUBLEBUF][lng_num] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
					strcpy(txt[TXT_DOUBLEBUF][lng_num],arg2);
#endif
/*********************************************************************************************************************************************/
				}else if (strcmp(arg1,"99")==0) ++lng_num;
			}
		}fclose(fp);
	}else{
		error.lng=1;
	}
}

void load_dat(void)
{
	signed int i;

	//check roms presentes
	error.dat=0;
	if ((fp = fopen("rage2x.dat", "r")) != NULL){
		nb_list[0]=0;
		while(fgets(ligne,sizeof(ligne),fp) != NULL){
			sscanf(ligne, "%s%s%s%d%d%s%s", &arg1,&arg2,&arg3,&data.year[nb_list[0]],&data.size[nb_list[0]],&arg6,&arg7);
			if (strcmp(arg1,"#")!=0){
				data.name[nb_list[0]] = (char*) malloc( strlen(arg1) * sizeof(char)+1);
				data.zip[nb_list[0]] = (char*) malloc( strlen(arg2) * sizeof(char)+1);
				data.manufacturer[nb_list[0]] = (char*) malloc( strlen(arg3) * sizeof(char)+1);
				data.type[nb_list[0]] = (char*) malloc( strlen(arg6) * sizeof(char)+1);
				data.status[nb_list[0]] = (char*) malloc( strlen(arg7) * sizeof(char)+1);
				strcpy(data.name[nb_list[0]],arg1);
				strcpy(data.zip[nb_list[0]],arg2);
				strcpy(data.manufacturer[nb_list[0]],arg3);
				strcpy(data.type[nb_list[0]],arg6);
				strcpy(data.status[nb_list[0]],arg7);
				nb_list[0]++;
			}
		}
		fclose(fp);
		// check des roms
		nb_list[1]=0;
		for (i=0;i<nb_list[0];++i){
			sprintf((char*)g_string, "%s%s.zip",options.path[0],data.zip[i]);
			if ((fp = fopen(g_string, "r")) != NULL){
				//position_jeux[nb_list[1]]=i;
				++nb_list[1];
				etat_jeux[i]=1;
				data.path[i]=0;
				fclose(fp);
			}else{
				sprintf((char*)g_string, "%s%s.zip",options.path[1],data.zip[i]);
				if ((fp = fopen(g_string, "r")) != NULL){
					//position_jeux[nb_list[1]]=i;
					++nb_list[1];
					etat_jeux[i]=1;
					data.path[i]=1;
					fclose(fp);
				}else etat_jeux[i]=0;
			}
		}
	}else{
		error.dat=1;
	}
}
